#define _XOPEN_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/wait.h>

#define KEY 175

void cleanup(int);

int main(int argc, char** argv) {
	int ident_sem;
	char *progs[] = {"prod", "cons"};
	const short buf_len = 1;	//	length of a buffer
	int nproc = 5;
	if(argc > 1) nproc = atoi(argv[1]);
	short initv[] = {0, buf_len, 1};
	ident_sem = semget(KEY, 3, 0777 | IPC_CREAT);
//	set the 3 semaphores to values from initv[]
	semctl(ident_sem, 0, SETALL, initv);

//	sem 0 - element dostepny
//	sem 1 - miejsce dostepne
//	sem 2 - operacje na buforze

	printf("\n");
	for(int i = 0; i < nproc; i++) {
		if(fork() == 0) execl(progs[0], progs[0], 0);
		if(fork() == 0) execl(progs[1], progs[1], 0);
	}
	for(int i = 0; i < 2*nproc; i++) wait(0);
	cleanup(ident_sem);
	return 0;
}

void cleanup(int ident_sem) {
	semctl(ident_sem, 3, IPC_RMID, 0);
	printf("\n******* cleanup\n\n");
	exit(1);
}

