#define _XOPEN_SOURCE 500
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <semaphore.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>

int main(void) {
	int i;
	char *p;
	sem_t *sem1;
	sem_t *sem2;

	// create, initialize semaphores
	sem1 = sem_open("/semaphore1", O_CREAT,  0644, 0);
	sem2 = sem_open("/semaphore2", O_CREAT,  0644, 1);

	if (fork()) { // Parent process
		for (i = 0; i < 10; i++) {
			sem_wait(sem2);
			for (p = "ab"; *p; p++) {
				write(1, p, 1);
//				usleep(100);
			}
			sem_post(sem1);
		}
		wait(NULL);

//	int sem_close(sem_t *sem);

//	sem_close() closes the named semaphore referred to by sem, allowing any
//	resources that the system has allocated to the calling process for this
//	semaphore to be freed.

//	int sem_unlink(const char *name);

//	sem_unlink() removes the named semaphore referred to by name. The semaphore
//	name is removed immediately. The semaphore is destroyed once all other
//	processes that have the semaphore open close it.

		sem_close(sem1);
		sem_close(sem2);
		sem_unlink("/semaphore1");
		sem_unlink("/semaphore2");
	} else { // Child process
		for (i = 0; i < 10; i++) {
			sem_wait(sem1); // Lock the semaphore
			for (p = "cd\n"; *p; p++) {
				write(1, p, 1);
//				usleep(100);
			}
			sem_post(sem2);
		}
		sem_close(sem1);
		sem_close(sem2);
	}
	return 0;
}

