#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>
#include <unistd.h>

sem_t sem;

void* thread(void* arg) {
	int* n = (int*) arg;
	sem_wait(&sem);
	printf("\nThread %d entered...\n", *n);

	//critical section
	sleep(2);

	printf("\nThread %d exiting...\n\n", *n);
	sem_post(&sem);
	return NULL;
}

//	int sem_init(sem_t *sem, int pshared, unsigned int value);

//	sem_init() initializes the unnamed semaphore at the address pointed to by
//	sem.  The value argument specifies the initial value for the semaphore.

//	The pshared argument indicates whether this semaphore is to be shared
//	between the threads of a process, or between processes.

//	If pshared has the value 0, then the semaphore is shared between the threads
//	of a process, and should be located at some address that is visible to all
//	threads (e.g., a global variable, or a variable allocated dynamically on the
//	heap).

//	If pshared is nonzero, then the semaphore is shared between processes, and
//	should be located in a region of shared memory.

int main() {
	sem_init(&sem, 0, 1);
	pthread_t t1, t2;
	int n1 = 1, n2 = 2;
	pthread_create(&t1, NULL, thread, &n1);
	pthread_create(&t2, NULL, thread, &n2);

	pthread_join(t1, NULL);
	pthread_join(t2, NULL);

// int sem_destroy(sem_t *sem);

//	sem_destroy() destroys the unnamed semaphore at the address pointed to by
//	sem.

//	Only a semaphore that has been initialized by sem_init(3) should be
//	destroyed using sem_destroy().

	sem_destroy(&sem);
	return 0;
}

