#define _XOPEN_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

#define KEY 75

void clean(int);
int ident_sem;

int main(int argc, char *argv[]) {
	union semun {
		int val;
		struct semid_ds *buf;
		unsigned short *array;
		struct seminfo *__buf;
	} arg;

	arg.val = 0;
	if(argc == 1) {	//	Operation P on the semaphore
		for(int i = 0; i < 20; i++) signal(i, clean);
		ident_sem = semget(KEY, 1, 0666 | IPC_CREAT);
		semctl(ident_sem, 0, SETVAL, arg);
		printf("\nSem : %d\n", semctl(ident_sem, 0, GETVAL));
		struct sembuf pbuf;
		pbuf.sem_op = -1;
		pbuf.sem_flg = 0;
		pbuf.sem_num = 0;
		semop(ident_sem, &pbuf, 1);
		printf("\nprocess P %d\n\n", getpid());
	} else {	//	Operation V on the semaphore
		ident_sem = semget(KEY, 1, 0777);
		struct sembuf vbuf;
		vbuf.sem_op = 1;
		vbuf.sem_flg = 0;
		vbuf.sem_num = 0;
		semop(ident_sem, &vbuf, 1);
		printf("\nprocess V %d\n\n", getpid());
	}
	return 0;
}

void clean(int i) {
	printf("\n");
	printf("Signal %d, cleaning up ...\n", i);
	printf("\n");
	semctl(ident_sem, 0, IPC_RMID, 0);
	exit(0);
}

