/* Semaphore example program */
/* We have two programs, sema and semb. Semb may be initiated at any 
 * time, but will be forced to wait until sema is executed. Sema and
 * semb do not have to be executed by the same user! */

#define _XOPEN_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

#define KEY (1492)

int main() {
	int id;
	struct sembuf operations;
	int retval;
	id = semget(KEY, 1, 0666);
	if(id < 0) {
		fprintf(stderr, "Program sema cannot find semaphore, exiting.\n");
		exit(0);
	}

/* Do a semaphore V-operation. */
	printf("\n");
	printf("Program sema about to do a V-operation. \n");
	printf("Process id is %d\n", getpid());
	operations.sem_num = 0;
	operations.sem_op = 1;
	operations.sem_flg = 0;

//	int semop(int semid, struct sembuf *sops, unsigned nsops);

//	semop() performs operations on selected semaphores in the set indicated by
//	semid. Each of the nsops elements in the array pointed to by sops specifies
//	an operation to be performed on a single semaphore.

	retval = semop(id, &operations, 1);
	if(retval == 0) {
		printf("Successful V-operation by program sema.\n");
		printf("Process id is %d\n", getpid());
	}
	else printf("sema: V-operation did not succeed.\n");
	printf("\n");
	return 0;
}

