/* Semaphore example program b */
/* We have two programs, sema and semb. Semb may be initiated at any 
 * time, but will be forced to wait until sema is executed. Sema and
 * semb do not have to be executed by the same user! */

/* HOW TO TEST:
 * Execute seminit
 * Execute semb &
 * The & is important - otherwise you would have have to move to
 * a different terminal to execute sema. Then execute sema. */

#define _XOPEN_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

#define KEY 1492

int main() {
	struct sembuf operations;
	int retval;
	int id = semget(KEY, 1, 0666);
	if(id < 0) {
		fprintf(stderr, "Program semb cannot find semaphore, exiting.\n");
		exit(0);
	}

/* Do a semaphore P-operation. */
	printf("\n");
	printf("\nProgram semb about to do a P-operation. \n");
	printf("Process id is %d\n", getpid());
	operations.sem_num = 0;	//	semaphore number
	operations.sem_op = -1;	//	semaphore operation
	operations.sem_flg = 0;	//	operation flags

//	int semop(int semid, struct sembuf *sops, size_t nsops);

//	semop() performs operations on selected semaphores in the set indicated by
//	semid. Each of the nsops elements in the array pointed to by sops is a
//	structure that specifies an operation to be performed on a single semaphore.
//	The elements of this structure are of type struct sembuf

	retval = semop(id, &operations, 1);
	if(retval == 0) {
		printf("Successful P-operation by program semb.\n");
		printf("Process id is %d\n", getpid());
	}
	else printf("semb: P-operation did not succeed.\n");
	printf("\n");
	return 0;
}

